'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formsyReact = require('formsy-react');

var _formsyReact2 = _interopRequireDefault(_formsyReact);

var _FormsyInput = require('./FormsyInput');

var _FormsyInput2 = _interopRequireDefault(_FormsyInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormsyWrapper = {};
var asyncValidationRules = {};

FormsyWrapper.addAsyncValidationRule = function (name, func) {
  asyncValidationRules[name] = func;
};

var FormsyFormWrapper = (_temp = _class = function (_Component) {
  _inherits(FormsyFormWrapper, _Component);

  function FormsyFormWrapper(props) {
    _classCallCheck(this, FormsyFormWrapper);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(FormsyFormWrapper).call(this, props));

    _this.state = {
      isValid: false,
      formClass: ''
    };
    return _this;
  }

  _createClass(FormsyFormWrapper, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        formsyWrapper: {
          getAsyncValidationRules: this.getAsyncValidationRules,
          setAsyncValidationState: this.setAsyncValidationState.bind(this)
        }
      };
    }
  }, {
    key: 'getAsyncValidationRules',
    value: function getAsyncValidationRules() {
      return asyncValidationRules;
    }
  }, {
    key: 'setAsyncValidationState',
    value: function setAsyncValidationState(isValid) {
      this.setState({ isValid: isValid });
    }

    /* Porting <Formsy.Form /> reset() */

  }, {
    key: 'reset',
    value: function reset() {
      this.refs.formsy.reset();
    }

    /* Porting <Formsy.Form /> getModel() */

  }, {
    key: 'getModel',
    value: function getModel() {
      this.refs.formsy.getModel();
    }

    /* Porting <Formsy.Form /> updateInputsWithError() */

  }, {
    key: 'updateInputsWithError',
    value: function updateInputsWithError(errors) {
      this.refs.formsy.updateInputsWithError(errors);
    }

    /* Porting <Formsy.Form /> onValid() */

  }, {
    key: 'onValid',
    value: function onValid() {
      var onValid = this.props.onValid;
      var isValid = this.state.isValid;

      if (isValid) {
        return onValid && onValid();
      }
    }

    /* Porting <Formsy.Form /> onInvalid() */

  }, {
    key: 'onInvalid',
    value: function onInvalid() {
      var onInvalid = this.props.onInvalid;
      var isValid = this.state.isValid;

      if (!isValid) {
        return onInvalid && onInvalid();
      }
    }

    /* Porting <Formsy.Form /> onChange() */

  }, {
    key: 'onChange',
    value: function onChange(currentValues, isChanged) {
      var onChange = this.props.onChange;

      this.setState({ formClass: '' });
      return onChange && onChange(currentValues, isChanged);
    }

    /* Porting <Formsy.Form /> onInvalidSubmit() */

  }, {
    key: 'onInvalidSubmit',
    value: function onInvalidSubmit(data, resetForm, invalidateForm) {
      var onInvalidSubmit = this.props.onInvalidSubmit;

      this.setState({ formClass: 'showFormError' });
      return onInvalidSubmit && onInvalidSubmit(data, resetForm, invalidateForm);
    }

    /* Porting <Formsy.Form /> onValidSubmit() */

  }, {
    key: 'onValidSubmit',
    value: function onValidSubmit(data, resetForm, invalidateForm) {
      var onValidSubmit = this.props.onValidSubmit;
      var isValid = this.state.isValid;

      if (isValid) {
        return onValidSubmit && onValidSubmit(data, resetForm, invalidateForm);
      }
      return false;
    }

    /* Porting <Formsy.Form /> onSubmit() */

  }, {
    key: 'onSubmit',
    value: function onSubmit(data, resetForm, invalidateForm) {
      var onSubmit = this.props.onSubmit;
      var isValid = this.state.isValid;

      if (isValid) {
        return onSubmit && onSubmit(data, resetForm, invalidateForm);
      }
      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      var newProps = _extends({}, this.props, {
        onValid: this.onValid.bind(this),
        onInvalid: this.onInvalid.bind(this),
        onChange: this.onChange.bind(this),
        onSubmit: this.onSubmit.bind(this),
        onInvalidSubmit: this.onInvalidSubmit.bind(this),
        onValidSubmit: this.onValidSubmit.bind(this),
        className: (this.props.className || '') + ' ' + this.state.formClass
      });
      return _react2.default.createElement(
        _formsyReact2.default.Form,
        _extends({}, newProps, { ref: 'formsy' }),
        this.props.children
      );
    }
  }]);

  return FormsyFormWrapper;
}(_react.Component), _class.propTypes = {
  children: _react.PropTypes.any
}, _class.childContextTypes = {
  formsyWrapper: _react.PropTypes.object
}, _temp);


FormsyWrapper.Form = FormsyFormWrapper;
FormsyWrapper.Input = _FormsyInput2.default;

exports.default = FormsyWrapper;